local emItemLink = {};
_G.emItemLink = emItemLink;
local frame = _G.emItemLink_Frame;

--local EMIL_VERSION = "Version 0.01";

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- スラッシュコマンド
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
SLASH_emItemLink1 = "/emItemLink";
SLASH_emItemLink2 = "/emil";
SlashCmdList[ "emItemLink" ] = function(editBox, msg)
	-- フレームを表示
	emItemLink_Frame:Show();
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- イベント登録
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
frame:RegisterEvent( "VARIABLES_LOADED" );

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- イベントハンドラ
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emItemLink:OnEvent( event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 )
	self[event]( self, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9 );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- ロード時
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emItemLink:VARIABLES_LOADED()
	DEFAULT_CHAT_FRAME:AddMessage( "emItemLink 0.01 loaded." );
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- ボタンハンドラ
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emItemLink:EnterButton()
	local strItemID = emilEdit:GetText();
	local hexItemID = emItemLink:DecToHex( tonumber(strItemID) );
	
	if ( hexItemID ~= nil ) then
		ChatEdit_OpenEditBox();
		ChatEdit_AddItemLink("|Hitem:"..hexItemID.."|h|cffffffcc[ITEM]|r|h");
	else
		DEFAULT_CHAT_FRAME:AddMessage( "emItemLink : Invalid ID." );
	end
end

--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
-- 10進　>> 16進
--_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
function emItemLink:DecToHex(dec)
    if not dec or type(dec) ~= "number" then
        return nil
    end

    local hexValues = "0123456789ABCDEF"
    local hex = ""
    while dec > 0 do
        local mod = math.fmod(dec, 16)+1
        hex = string.sub(hexValues, mod, mod) .. hex
        dec = math.floor(dec / 16)
    end
    if hex == "" then hex = "0" end
    return hex
end
